#ifndef   __LEDDISPLAY_
#define   __LEDDISPLAY_

struct DIS_STRUCT
{
  uint8_t   u8hundred;          
  uint8_t   u8ten;            
  uint8_t   u8single;         
  uint8_t   u8left;       
  uint8_t   u8right;
  uint8_t   u8step;  
};  


#define  COM1_BIT    0x08
#define  COM1_ODR    P3
#define  COM1_DDR    P3M
#define  COM1_H      COM1_ODR|=COM1_BIT
#define  COM1_L      COM1_ODR&=~COM1_BIT
#define  COM1_OUT    COM1_DDR|=COM1_BIT
#define  COM1_IN     COM1_DDR&=~COM1_BIT

#define  COM2_BIT    0x10
#define  COM2_ODR    P3
#define  COM2_DDR    P3M
#define  COM2_H      COM2_ODR|=COM2_BIT
#define  COM2_L      COM2_ODR&=~COM2_BIT
#define  COM2_OUT    COM2_DDR|=COM2_BIT
#define  COM2_IN     COM2_DDR&=~COM2_BIT

#define  COM3_BIT    0x20
#define  COM3_ODR    P3
#define  COM3_DDR    P3M
#define  COM3_H      COM3_ODR|=COM3_BIT
#define  COM3_L      COM3_ODR&=~COM3_BIT
#define  COM3_OUT    COM3_DDR|=COM3_BIT
#define  COM3_IN     COM3_DDR&=~COM3_BIT

#define  COM4_BIT    0x04
#define  COM4_ODR    P2
#define  COM4_DDR    P2M
#define  COM4_H      COM4_ODR|=COM4_BIT
#define  COM4_L      COM4_ODR&=~COM4_BIT
#define  COM4_OUT    COM4_DDR|=COM4_BIT
#define  COM4_IN     COM4_DDR&=~COM4_BIT

#define  COM5_BIT    0x02
#define  COM5_ODR    P2
#define  COM5_DDR    P2M
#define  COM5_H      COM5_ODR|=COM5_BIT
#define  COM5_L      COM5_ODR&=~COM5_BIT
#define  COM5_OUT    COM5_DDR|=COM5_BIT
#define  COM5_IN     COM5_DDR&=~COM5_BIT

#define  COM6_BIT    0x40
#define  COM6_ODR    P1
#define  COM6_DDR    P1M
#define  COM6_H      COM6_ODR|=COM6_BIT
#define  COM6_L      COM6_ODR&=~COM6_BIT
#define  COM6_OUT    COM6_DDR|=COM6_BIT
#define  COM6_IN     COM6_DDR&=~COM6_BIT

#define BIT_A    0x01
#define BIT_B    0x02
#define BIT_C    0x04
#define BIT_D    0x08
#define BIT_E    0x10
#define BIT_F    0x20
#define BIT_G    0x40

extern struct DIS_STRUCT structDis;

void display_drive(void);
void displayService(void);
uint8_t adc_to_percnet(void);
extern void dis_ctr(void);
#endif