#include "FC2720.h"

enum status
{
  STATUS_POWER_ON,STATUS_ON,STATUS_OFF
};

#define   RELAY_ON      FP13=0
#define   RELAY_OFF     FP13=1  
#define   R_LED_OFF     FP11=0  
#define   R_LED_ON      FP11=1


bit       bit1ms=0;
bit       bit200ms=0;
bit       bitFinish=0;
enum status u8status=STATUS_POWER_ON;
uint16_t u16AdcFilterValue=0;
/*Function statment<<=========================================================*/
void system_init(void);
void get_adc(void);
void t0_enable(void);
void adc_init(void);
void delay_1ms(uint8_t x_1ms);
/******************************************************************************************************
*      ƣжϷ
*      ܣֻ
*  ڲ
*  ڲ
*      ڣ2019.6.14
*      ߣм
******************************************************************************************************/
void __interrupt[0x8] isr(void)
{
  static uint8_t x=0;	
  if(FT0IF)
  {
	FT0IF=0;    
    T0C=68;      //װֵ	  
    bit1ms=1;	
	x++;
	if(x>199)
	{
	  x=0;
	  bit200ms=1;
	}
  }	
//  INTRQ=0;
//  INTRQ1=0;			
}
/******************************************************************************************************
*      ƣ
*      ܣ
*  ڲ   
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void main(void)
{
    uint8_t j=0;
    while(1)
    {   
      WDTR=0x5A;
	  switch(u8status)
	  {
	    case STATUS_POWER_ON:
        {
          system_init();
	      adc_init();
          for(j=0;j<200;j++)
          {
	        delay_1ms(1);
	        get_adc();
          }
          j=0;
	      u8status=STATUS_ON;
		}   
		break;

	    case STATUS_ON:
		RELAY_ON;
		R_LED_OFF;
	    get_adc();
        if(bitFinish)
        {
          bitFinish=0;
	      if(u16AdcFilterValue>3549)//2.6V
	      {
		    j++; 
            if(j>20)
            {
			  j=0;
			  t0_enable();
              R_LED_ON;
    	      u8status=STATUS_OFF;
			}   
	      } 
          else 
          {
		    j=0;
          } 		  
		}          
		break;

	    case STATUS_OFF:
		RELAY_OFF;
        if(bit200ms)
		{
		  bit200ms=0;
		  j++;
		  if(j<150)
		  {
		    R_LED_ON;//30
		  } 
		  else
		  {
		    j=0;
		    R_LED_OFF;//Ȼ2
	        u8status=STATUS_POWER_ON;
		  }
		}  
		break;
	  }
  
	}
}
/******************************************************************************************************
*      : ʼADC
*      ܣѡòͨͲοѹ
*  ڲ   
*  ڲ
*      ڣ2019.9.28
*      ߣ
******************************************************************************************************/
void adc_init(void)
{
  ADPCON=0x01;   //صŵʩش  
  VREFH =0x01;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADR   =0xF0;   //ADFcpu 
  ADM   =0x90;   //ѡADͨ
}	
/******************************************************************************************************
*      : get_adc 
*      ܣѯADCתģʽ,жģʽ
*  ڲ   
*  ڲ
*      ڣ2018.1.4
*      ߣ
******************************************************************************************************/
#define      N        8        //Nֵ8   

void get_adc(void)
{
  static uint8_t   cnt=0;
  static uint8_t   u8Step=0;
  static uint16_t  max=0;
  static uint16_t  min=0;
  static uint16_t  sum=0;
  static uint16_t  u16AdcNow=0;
  	
		 
  FADS =1;               //ʼADCת
  while(FADS);           //ȴADCת
  u16AdcNow=ADB;         //ȶȡ8λ 
  u16AdcNow<<=4;         //Ƶ8λ
  u16AdcNow +=(ADR&0x0F);//ٶȡλ

  switch(u8Step)
  {
    case 0:
	{
	  sum=u16AdcNow;//ʼsum
	  min=u16AdcNow;//ʼmin
	  max=u16AdcNow;//ʼmax
	  cnt++;
	  u8Step=1;
	}
	break;
		
	case 1:
	if(u16AdcNow>max)
	{
	  max=u16AdcNow;            //ֵ	
	}	
	else if(u16AdcNow<min)
	{
	  min=u16AdcNow;		   //Сֵ
	}
	sum+=u16AdcNow;            //׷ӵֵ
	cnt++;
	if(cnt>(N-1))
	{	
	  sum=sum-max-min;
	  u16AdcFilterValue=sum/(N-2);//ƽֵ=(ֵ-ֵ-Сֵ)/(г-2)  
      cnt=0;
	  u8Step=0;	 
	  bitFinish=1;     
	}
	break;
		 
	default:
	{
	  cnt=0;
	  u8Step=0;
	}
	break;
  } 
} 	
/******************************************************************************************************
*      ƣvoid delay_1ms(uint8_t x_1ms)
*      ܣʱ x_1ms ,ϵͳƵΪ12M/4
*  ڲx_1ms    
*  ڲ
*      ڣ2017.11.14
*      ߣм
******************************************************************************************************/
void delay_1ms(uint8_t x_1ms)
{
  uint8_t i=0;
  for(;x_1ms>0;x_1ms--)
  {
    for(i=249;i>0;i--)
	{
      __asm{nop};
	  __asm{nop};
	  __asm{nop};
	  __asm{nop};
      __asm{nop};
      __asm{nop};
    }
  }
}
/******************************************************************************************************
*      ƣvoid t0_enable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_enable(void)
{
  T0M=0xC0;       //T0TR T0PS2 T0PS1 T0PS0 - - - -   000,Fcpu/256 001/128 010/64 011/32 100/16 101/8 110/4 111/2
  T0C=68;        //
  FT0IE=1;         //T0ж
  FGIE=1;
}
/******************************************************************************************************
*      ƣvoid t0_disable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_disable(void)
{
  T0M=0x00;	
  FT0IE=0;
}
/******************************************************************************************************
*      ƣvoid system_init(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void system_init(void)
{
  ADPCON=0x00;     
  ADR  =0x00;   //
  VREFH=0x00;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADM  =0x00;   //

  T0M=0x00;	
  FT0IE=0; 
  TM1M =0x00;   
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;
  FGIE=0;
	
  //
  P1   =0x00;
  P1M  =0xFB;      //0 =  ģʽ   1 =  ģʽ	
  P1W  =0x00;  
  P1UR =0x00;      //P_KEY_1  
  P1PD =0x00;
  
  P3   =0x00;       //
  P3M  =0xF0;       //
  P3W  =0x00;       //
  P3UR =0x00;       //0 =     1 =  	
  P3PD =0x00;       //0 =     1 =  
}
